Debian Bug report logs - #588118
libmoose-perl [ia64]: test failures

version graph

Package: libmoose-perl; Maintainer for libmoose-perl is Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>; Source for libmoose-perl is src:libmoose-perl.

Reported by: Ansgar Burchardt <ansgar@2008.43-1.org>

Date: Mon, 5 Jul 2010 02:45:01 UTC

Severity: serious

Tags: patch

Found in version libmoose-perl/1.06-1

Fixed in version libmoose-perl/1.09-2

Done: gregor herrmann <gregoa@debian.org>

Bug is archived. No further changes may be made.

Forwarded to https://rt.cpan.org/Public/Bug/Display.html?id=59478

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#588118; Package libmoose-perl. (Mon, 05 Jul 2010 02:45:04 GMT) Full text and rfc822 format available.

Message #3 received at submit@bugs.debian.org (full text, mbox):

From: Ansgar Burchardt <ansgar@2008.43-1.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: libmoose-perl [ia64]: test failures
Date: Mon, 05 Jul 2010 11:43:40 +0900
Package: libmoose-perl
Version: 1.06-1
Severity: serious
Justification: fails to build from source

The tests for libmoose-perl fail on ia64 since version 1.06.  At first
glance none of the changes looks likely to have introduced this
regression:

The only change in 1.06 was a new feature:

  [NEW FEATURES]
  * Added '0+' overloading in Moose::Meta::TypeConstraint so that we
    can more uniformly compare type constraints between 'classic' Moose
    type constraints and MooseX::Types based type constraints.

Which was accomplished by these changes:

--- a/lib/Moose/Meta/TypeConstraint.pm
+++ b/lib/Moose/Meta/TypeConstraint.pm
@@ -5,7 +5,9 @@ use strict;
 use warnings;
 use metaclass;
 
-use overload '""'     => sub { shift->name },   # stringify to tc name
+use overload '0+'     => sub { refaddr(shift) }, # id an object
+             '""'     => sub { shift->name },   # stringify to tc name
+             bool     => sub { 1 },
              fallback => 1;
 
 use Scalar::Util qw(blessed refaddr);
@@ -133,7 +135,7 @@ sub equals {
 
     my $other = Moose::Util::TypeConstraints::find_type_constraint($type_or_name) or return;
 
-    return 1 if refaddr($self) == refaddr($other);
+    return 1 if $self == $other;
 
     if ( $self->has_hand_optimized_type_constraint and $other->has_hand_optimized_type_constraint ) {
         return 1 if $self->hand_optimized_type_constraint == $other->hand_optimized_type_constraint;

Also a new test was introduced.

There are no changes to the XS code, even the version of Class::MOP (1.02) is
the same version use to build Moose 1.05 where the tests passed.  The tests
also passed on all other architectures.

I don't have access to a ia64 host so I cannot really investigate this problem
myself.  One of the many reasons I look forward to finally finish waiting for
NM to proceed someday :-/

Regards,
Ansgar




Added tag(s) help. Request was from gregor herrmann <gregoa@debian.org> to control@bugs.debian.org. (Sat, 17 Jul 2010 14:18:21 GMT) Full text and rfc822 format available.

Set Bug forwarded-to-address to 'https://rt.cpan.org/Public/Bug/Display.html?id=59478'. Request was from gregor herrmann <gregoa@debian.org> to control@bugs.debian.org. (Sat, 17 Jul 2010 14:33:17 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#588118; Package libmoose-perl. (Tue, 10 Aug 2010 08:03:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ansgar Burchardt <ansgar@43-1.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Tue, 10 Aug 2010 08:03:03 GMT) Full text and rfc822 format available.

Message #12 received at 588118@bugs.debian.org (full text, mbox):

From: Ansgar Burchardt <ansgar@43-1.org>
To: 588118@bugs.debian.org
Subject: Re: Bug#588118: libmoose-perl [ia64]: test failures
Date: Tue, 10 Aug 2010 17:01:05 +0900
Hi,

rafl took a first look at this some time ago and suspects this might be
a bug in perl somewhere.

I am also curious if this only affects 1.06 or if also older version
(that is 1.05-1 from testing) also FTBFS.  Could some DD try to build
the older version on a IA64 porter machine?  (If you are lucky the
Build-Deps are still installed somewhere.)

Another problem is that this holds back the newer version of
libmoosex-types-structured-perl that fixes another FTBFS.

Regards,
Ansgar




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#588118; Package libmoose-perl. (Fri, 20 Aug 2010 19:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Fri, 20 Aug 2010 19:39:03 GMT) Full text and rfc822 format available.

Message #17 received at 588118@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 588118@bugs.debian.org
Cc: perl@packages.debian.org
Subject: Re: Bug#588118: libmoose-perl [ia64]: test failures
Date: Fri, 20 Aug 2010 22:35:22 +0300
[Message part 1 (text/plain, inline)]
tag 588118 - help
clone 588118 -1
reassign -1 perl 5.10.1-14
retitle -1 perl: numeric overloading problem on ia64
severity -1 important
tag 588118 + patch
thanks

On Tue, Aug 10, 2010 at 05:01:05PM +0900, Ansgar Burchardt wrote:

> I am also curious if this only affects 1.06 or if also older version
> (that is 1.05-1 from testing) also FTBFS.  Could some DD try to build
> the older version on a IA64 porter machine?  (If you are lucky the
> Build-Deps are still installed somewhere.)

1.05-1 passes all tests on merulo.d.o but 1.06-1 and 1.09-1 don't
so it's not a regression in the build dependencies.

It boils down to the attached test, which apparently fails on ia64
but passes everywhere else. I assume this is a bug in perl but I'm not
quite sure yet.  Cloning and reassigning against perl, will investigate
more later.

I'm attaching a simple workaround that makes the 1.09-1 test suite pass
for me.
-- 
Niko Tyni   ntyni@debian.org
[overload.t (text/plain, attachment)]
[0001-Work-around-a-numification-problem-on-ia64.patch (text/x-diff, attachment)]

Removed tag(s) help. Request was from Niko Tyni <ntyni@debian.org> to control@bugs.debian.org. (Fri, 20 Aug 2010 19:39:04 GMT) Full text and rfc822 format available.

Bug 588118 cloned as bug 593764. Request was from Niko Tyni <ntyni@debian.org> to control@bugs.debian.org. (Fri, 20 Aug 2010 19:39:05 GMT) Full text and rfc822 format available.

Added tag(s) patch. Request was from Niko Tyni <ntyni@debian.org> to control@bugs.debian.org. (Fri, 20 Aug 2010 19:39:10 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#588118; Package libmoose-perl. (Fri, 20 Aug 2010 20:18:08 GMT) Full text and rfc822 format available.

Message #26 received at 588118@bugs.debian.org (full text, mbox):

From: pkg-perl-maintainers@lists.alioth.debian.org
To: 588118@bugs.debian.org, 588118-submitter@bugs.debian.org
Subject: Bug in libmoose-perl fixed in revision 61802
Date: Fri, 20 Aug 2010 20:15:52 +0000
tag 588118 + pending
thanks

Some bugs are closed in revision 61802
by Gregor Herrmann (gregoa)

Commit message:

Add patch 0001-Work-around-a-numification-problem-on-ia64.patch:
explicitly numify before doing numeric comparsions as a workaround for a
numification problem on ia64 (closes: #588118). Thanks to Niko Tyni for
the analysis and the patch!




Added tag(s) pending. Request was from pkg-perl-maintainers@lists.alioth.debian.org to control@bugs.debian.org. (Fri, 20 Aug 2010 20:18:09 GMT) Full text and rfc822 format available.

Message sent on to Ansgar Burchardt <ansgar@2008.43-1.org>:
Bug#588118. (Fri, 20 Aug 2010 20:18:11 GMT) Full text and rfc822 format available.

Reply sent to gregor herrmann <gregoa@debian.org>:
You have taken responsibility. (Fri, 20 Aug 2010 20:57:05 GMT) Full text and rfc822 format available.

Notification sent to Ansgar Burchardt <ansgar@2008.43-1.org>:
Bug acknowledged by developer. (Fri, 20 Aug 2010 20:57:05 GMT) Full text and rfc822 format available.

Message #36 received at 588118-close@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregoa@debian.org>
To: 588118-close@bugs.debian.org
Subject: Bug#588118: fixed in libmoose-perl 1.09-2
Date: Fri, 20 Aug 2010 20:53:15 +0000
Source: libmoose-perl
Source-Version: 1.09-2

We believe that the bug you reported is fixed in the latest version of
libmoose-perl, which is due to be installed in the Debian FTP archive:

libmoose-perl_1.09-2.debian.tar.gz
  to main/libm/libmoose-perl/libmoose-perl_1.09-2.debian.tar.gz
libmoose-perl_1.09-2.dsc
  to main/libm/libmoose-perl/libmoose-perl_1.09-2.dsc
libmoose-perl_1.09-2_i386.deb
  to main/libm/libmoose-perl/libmoose-perl_1.09-2_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 588118@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
gregor herrmann <gregoa@debian.org> (supplier of updated libmoose-perl package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Fri, 20 Aug 2010 22:18:02 +0200
Source: libmoose-perl
Binary: libmoose-perl
Architecture: source i386
Version: 1.09-2
Distribution: unstable
Urgency: low
Maintainer: Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>
Changed-By: gregor herrmann <gregoa@debian.org>
Description: 
 libmoose-perl - modern Perl object system framework
Closes: 588118
Changes: 
 libmoose-perl (1.09-2) unstable; urgency=low
 .
   * Add patch 0001-Work-around-a-numification-problem-on-ia64.patch:
     explicitly numify before doing numeric comparsions as a workaround for a
     numification problem on ia64 (closes: #588118). Thanks to Niko Tyni for
     the analysis and the patch!
Checksums-Sha1: 
 955fe03cbe6acb870477a614ba552d16439b3c6c 2870 libmoose-perl_1.09-2.dsc
 a298f0bce40ab63c7f0d00aab18b6af748f276c4 8830 libmoose-perl_1.09-2.debian.tar.gz
 fd3738f3743e24e068a90a398b489fcd8ec4b3fc 657686 libmoose-perl_1.09-2_i386.deb
Checksums-Sha256: 
 04c0da45c8497f36fffb1f2999fcf5215d03ba70d145442d295ea89bcca76492 2870 libmoose-perl_1.09-2.dsc
 7976d0c8aeb69206727ce7570d454c98698ad4b00268fb5670126cc2dc89bf2a 8830 libmoose-perl_1.09-2.debian.tar.gz
 591670e23e80528f728aca28636d7d9e9651adf1f01a74086bff019bb210e3b1 657686 libmoose-perl_1.09-2_i386.deb
Files: 
 547394d84b82924fa3292db54e49229e 2870 perl optional libmoose-perl_1.09-2.dsc
 5969a7fc782a794c427c222c0d08b9d8 8830 perl optional libmoose-perl_1.09-2.debian.tar.gz
 e57ddcb753fc11dbfee73ff9abb45b70 657686 perl optional libmoose-perl_1.09-2_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iQIcBAEBCAAGBQJMbuRLAAoJELs6aAGGSaoGGp4P+wTuZa0C3TMpHanWjpdA6Grm
n0V4XkHG+dbDwJ3OuTx9iN/X4RsjKvKLm63Aw4SshO0OP2E6N+MCv2/2YLmPb1zZ
B6WGVNehrcNTxWAjJZZjZpq3xghEz3m94+CV1QDsgnRP+5F6NT7MvrG2MNe/Uf95
9hxmk+Aepagrp1+2RBGoJUDSH84wWrx2QhsTrX1OB5j6vhaxRAQz0VIwwgXApImE
YZq25NjHiuPZRFNSksTVHN75ZiwH3pIp8TRMHsAGq+j7ePBuxD9h1gi6IaRmd4Wj
pg8Chlv5P0vgDPpPz1C8MjOQfEC/CthX8kalWHvmDx6kszE19OKg/5oAsWT7JSUS
LPEHjAkwoV3d8KQZoO7Eh0yzxY3tl5hh5EhVr8IuEB1SldW6yO5MnRXtEEq9Dl/J
Udfaj0QxKwyf/DoCpoobtDvWkqlr0lKe587wRORYivka2kywUFRtvyXYD3hCVTOL
NiczvBtQuXfiKIuKPtrQllE1VJ9I1YgY+MAJlv47DkwtODtEWbT7PLXeUU9C5Fs/
gqVrEq/JS+FihZh8azmbK8uYLblx4RiOW+TEm9RZgx6Ec0X93Qrye8H2oDKbxRs5
flr8EyNCN9Zq0CWCkCXfwjums2pzpULX39YYo1zpLCYcUDkHhMMgM74+0v3gzVRF
pcJK5FcVXxRdmnQ/IpF3
=bvD2
-----END PGP SIGNATURE-----





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>:
Bug#588118; Package libmoose-perl. (Wed, 25 Aug 2010 10:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Niko Tyni <ntyni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Perl Group <pkg-perl-maintainers@lists.alioth.debian.org>. (Wed, 25 Aug 2010 10:51:03 GMT) Full text and rfc822 format available.

Message #41 received at 588118@bugs.debian.org (full text, mbox):

From: Niko Tyni <ntyni@debian.org>
To: 593764@bugs.debian.org
Cc: 588118@bugs.debian.org
Subject: Re: perl: numeric overloading problem on ia64
Date: Wed, 25 Aug 2010 13:47:08 +0300
What seems to be happening is an integer -> float conversion
somewhere behind the curtains during overloading / numification.

This is reproducible on amd64 with

#!/usr/bin/perl -w

package Foo;

my $i = 0;
use overload '0+' => sub { (1 << 53) + ($i++) },
             fallback => 1;

1;

package main;

print "1..2\n";
my $f1 = bless {}, 'Foo';
my $f2 = bless {}, 'Foo';

print ((($f1 == $f2) ? "not " : "") . "ok 1\n");
print (((0+$f1 == 0+$f2) ? "not " : "") . "ok 2\n");
__END__

which fails test 1 but not test 2.

Clearly the IV is coerced into an NV in the first case, losing precision
(both types are 64 bits wide) and making the values compare as equal.

The special thing about ia64 is that its reference addresses are big
integers and not small ones.

This looks like a bug to me , but I suppose it could be argued to be
a feature.  I'll file an upstream bug and see what they think. It does
happen with current bleadperl FWIW.
-- 
Niko Tyni   ntyni@debian.org




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 23 Sep 2010 07:32:55 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 24 21:29:08 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.